//====================================================== file = outport.c =====
//=  Output port for VOQ switch simulation model                              =
//=============================================================================
//=  Notes: 1)                                                                =
//=---------------------------------------------------------------------------=
//=  Contains: outport()                                                      =
//=---------------------------------------------------------------------------=
//=  History:  KJC (11/15/00) - Genesis                                       =
//=============================================================================
#define EXTERNAL        // This is an external file (used in common.h)

//----- Include files ---------------------------------------------------------
#include "csim.h"       // Needed for CSIM
#include "common.h"     // Needed for common stuff

//============================================================================
//==  Output port for VOQ switch simulation model                           ==
//============================================================================
void outport(int from_id, int out_id, double org_time)
{
  create("outport");

  // Record delay statistics for cells leaving this port
  record((clock - org_time), Delay_table[out_id]);

  // Decrement counter semphores for an inport and outport pair
  Inport_count[from_id]--;
  Outport_count[out_id]--;

  // Clear port busy events and set transmit done event
  clear(Inport_busy[from_id]);
  clear(Outport_busy[out_id]);
  set(Xmit_done[out_id]);

  return;
}
